datablock TSShapeConstructor(SpaceMarineDTS)
{
	baseShape = "./sm.dts";
	sequence0 = "./default.dsq";
	sequence1 = "./m_spacemarine_fix.dsq";
};

datablock PlayerData(SpaceMarineArmor : PlayerStandardArmor)
{
	shapeFile = "./sm.dts";
	uniformCompatible = true;
	canJet = true;
	uiName = "Space Marine";
	
	boundingBox = "7 7 13";
	crouchBoundingBox = "8 13 5";
	
	isSpaceMarine = true;
};

datablock TSShapeConstructor(ChaosSpaceMarineDTS)
{
	baseShape = "./c_sm.dts";
	sequence0 = "./default.dsq";
	sequence1 = "./m_spacemarine_fix.dsq";
};

datablock PlayerData(ChaosSpaceMarineArmor : PlayerStandardArmor)
{
	shapeFile = "./c_sm.dts";
	uniformCompatible = true;
	canJet = true;
	uiName = "Chaos Space Marine";
	
	boundingBox = "7 7 13";
	crouchBoundingBox = "8 13 5";
	
	isSpaceMarine = true;
	isChaosSpaceMarine = true;
};

datablock PlayerData(ChaosSpaceMarineNoJetArmor : ChaosSpaceMarineArmor)
{
	canJet = false;
	uiName = "No-Jet Chaos Space Marine";
};

datablock PlayerData(NoJetSpaceMarineArmor : PlayerStandardArmor)
{
	shapeFile = "./sm.dts";
	uniformCompatible = true;
	canJet = false;
	uiName = "No-Jet Space Marine";
	
	boundingBox = "7 7 13";
	crouchBoundingBox = "8 13 5";
	
	isSpaceMarine = true;
};

function Player::configureSpaceMarine(%obj)
{
	// explanation for the next 40 or so lines: i imported jack noyer's melee playertype and just glued space marine body parts onto their corresponding limbs because i'm a hack with no animation skills
	%obj.hideNode("ALL");
	
	%obj.unHideNode("chest");
	%obj.unHideNode("pants");
	%obj.unHideNode("rarm");
	%obj.unHideNode("larm");
	%obj.unHideNode("lshoe");
	%obj.unHideNode("rshoe");
	%obj.unHideNode("skulldec");
	%obj.unHideNode("rarmdec");
	%obj.unHideNode("larmdec");
	%obj.unHideNode("eyes");
	%obj.unHideNode("lhand");
	%obj.unHideNode("rhand");
	%obj.unHideNode("chestinner");
	%obj.unHideNode("jetblack");
	%obj.unHideNode("jetdec1");
	%obj.unHideNode("jetdec2");
	%obj.unHideNode("jetdec3");
	%obj.unHideNode("jetdec4");
	%obj.unHideNode("ljetnozzle");
	%obj.unHideNode("rjetnozzle");
	%obj.unHideNode("ljetline");
	%obj.unHideNode("rjetline");
	%obj.unHideNode("lkneecap");
	%obj.unHideNode("rkneecap");
	%obj.unHideNode("lleg");
	%obj.unHideNode("rleg");
	%obj.unHideNode("jetpack");
	%obj.unHideNode("gasmask");
	%obj.unHideNode("headpiece");
	%obj.unHideNode("lcuff");
	%obj.unHideNode("rcuff");
	
	if(%obj.getDatablock().isChaosSpaceMarine)
	{
		%obj.unHideNode("skulldec2");
		%obj.unHideNode("jetdec5");
		%obj.unHideNode("horns");
	}
	
	%red = (216 / 255) SPC (52 / 255) SPC (52 / 255) SPC 1.0;
	%obj.setNodeColor("eyes", %red);
}

package WarhammerPlayer
{
	function Armor::onNewDataBlock(%this, %obj)
	{
		Parent::onNewDataBlock(%this, %obj);
		
		if(%this.isSpaceMarine)
			%obj.schedule(50, applyBodyColors);
	}
	
	function GameConnection::applyBodyColors(%client) 
	{
		Parent::applyBodyColors(%client);
		
		if(isObject(%obj = %client.player))
		{
			if(%obj.getDatablock().isSpaceMarine)
			{
				%obj.configureSpaceMarine();
				
				%obj.setNodeColor("chest", %client.chestColor);
				%obj.setNodeColor("jetpack", %client.chestColor);
				
				%obj.setNodeColor("headpiece", %client.headColor);
				
				%obj.setNodeColor("lhand", %client.LHandColor);
				%obj.setNodeColor("rhand", %client.RHandColor);
				%obj.setNodeColor("lcuff", %client.LHandColor);
				%obj.setNodeColor("rcuff", %client.RHandColor);
				
				%obj.setNodeColor("rarm", %client.LArmColor);
				%obj.setNodeColor("larm", %client.RArmColor);
				
				%obj.setNodeColor("rarmdec", %client.secondPackColor);
				%obj.setNodeColor("larmdec", %client.secondPackColor);
				
				%obj.setNodeColor("gasmask", %client.hatColor);
				
				%obj.setNodeColor("jetdec1", getWords(%client.accentColor, 0, 2) SPC 1.0);
				%obj.setNodeColor("jetdec2", getWords(%client.accentColor, 0, 2) SPC 1.0);
				%obj.setNodeColor("jetdec3", getWords(%client.accentColor, 0, 2) SPC 1.0);
				%obj.setNodeColor("jetdec4", %client.chestColor);
				
				if(%obj.getDatablock().isChaosSpaceMarine)
					%obj.setNodeColor("jetdec5", getWords(%client.accentColor, 0, 2) SPC 1.0);
				
				%obj.setNodeColor("pants", %client.hipColor);
				
				%obj.setNodeColor("rshoe", %client.RLegColor);
				%obj.setNodeColor("lshoe", %client.LLegColor);
				%obj.setNodeColor("rkneecap", %client.RLegColor);
				%obj.setNodeColor("lkneecap", %client.LLegColor);
				%obj.setNodeColor("rleg", %client.RLegColor);
				%obj.setNodeColor("lleg", %client.LLegColor);
				
				%obj.setNodeColor("chestinner", %client.packColor);
				%obj.setNodeColor("skulldec", %client.packColor);
				
				if(%obj.getDatablock().isChaosSpaceMarine)
					%obj.setNodeColor("skulldec2", %client.packColor);
			}
		}
	}
	
	function GameConnection::applyBodyParts(%client) 
	{
		Parent::applyBodyParts(%client);
		
		if(isObject(%obj = %client.player))
			if(%obj.getDatablock().isSpaceMarine)
				%obj.configureSpaceMarine();
	}
	
	function serverCmdUpdateBodyParts(%client, %hat, %accent, %pack, %secondPack, %chest, %hip, %LLeg, %RLeg, %LArm, %RArm, %LHand, %RHand)
	{
		if(isObject(%obj = %client.player))
			if((%obj.getDatablock()).isSpaceMarine)
				return;
		
		Parent::serverCmdUpdateBodyParts(%client, %hat, %accent, %pack, %secondPack, %chest, %hip, %LLeg, %RLeg, %LArm, %RArm, %LHand, %RHand);
	}
	
	function serverCmdSit(%client)
	{
		if(isObject(%obj = %client.player))
			if(%obj.getDatablock().isSpaceMarine)
				return;
		
		Parent::serverCmdSit(%client);
	}
};
ActivatePackage(WarhammerPlayer);